/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.system.action;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.dao.MCodeDao;
import jp.mosp.common.dto.MCodeDto;
import jp.mosp.kintai.system.vo.CodeMasterCardVo;

/**
 * @author yoshida
 *
 */
public class CodeMasterCardAction extends MosPAction {
	
	// コマンド
	private static final String	CMD_CODE_CARD_SHOW		= "S2025";	// 表示(追加)
	private static final String	CMD_CODE_CARD_SELECT	= "S2026";	// 表示(選択)
	private static final String	CMD_CODE_CARD_INSERT	= "S2027";	// 登録
	private static final String	CMD_CODE_CARD_UPDATE	= "S2028";	// 更新
	private static final String	CMD_CODE_CARD_DELETE	= "S2029";	// 削除
																	
	
	/**
	 * コンストラクタ
	 */
	public CodeMasterCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得及び設定
		prepareVo(false);
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_CODE_CARD_SHOW)) {
			// 表示(新規)
			show();
		} else if (cmd.equals(CMD_CODE_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			select();
		} else if (cmd.equals(CMD_CODE_CARD_INSERT)) {
			// 新規登録
			insert();
		} else if (cmd.equals(CMD_CODE_CARD_UPDATE)) {
			// 更新
			update();
		} else if (cmd.equals(CMD_CODE_CARD_DELETE)) {
			// 削除
			delete();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new CodeMasterCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		// コード区分プルダウンリスト作成
		vo.aryPltTId = getMosPCodeArray();
	}
	
	@Override
	protected void show() {
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		vo.setPltTId("");
		vo.setTxtTCode("");
		vo.setTxtTName("");
		vo.setTxtTChange("");
		vo.setMode(CodeMasterCardVo.MODE_INSERT);
	}
	
	@Override
	protected void select() throws Exception {
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		// データの取得
		MCodeDto dto = part().mospcode().findForKey(key1, key2);
		chkExist(dto);
		// VOに情報をセット
		vo.setFields(dto);
		setMode();
		// セッションにDTOをセット
		setSessionDto(dto);
	}
	
	@Override
	protected void insert() throws Exception {
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		MCodeDto dto = new MCodeDto();
		vo.setDtoFields(dto);
		// DAOの準備
		MCodeDao dao = part().mospcode().getMCodeDao();
		// 存在チェック
		chkDuplicate(dao.findForKey(dto.getTId(), dto.getTCode()));
		// データの挿入
		dao.insert(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkInsert(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_INSERT, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	@Override
	protected void update() throws Exception {
		// DTOの取得
		MCodeDto dto = (MCodeDto)getSessionDto();
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		vo.setParams(request);
		// コード区分取得
		vo.setPltTId(dto.getTId());
		vo.setTxtTCode(dto.getTCode());
		// パラメータの妥当性確認
		vo.validate();
		// DTOの準備
		vo.setDtoFields(dto);
		// DAOの準備
		MCodeDao dao = part().mospcode().getMCodeDao();
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(dto.getTId(), dto.getTCode()));
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MCodeDto retDto = dao.findForKey(dto.getTId(), dto.getTCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode();
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_UPDATE, ""));
		// セッションにDTOをセット
		setSessionDto(retDto);
	}
	
	/**
	 * データ削除
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void delete() throws Exception {
		// DTOの取得
		MCodeDto dto = (MCodeDto)getSessionDto();
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		// データの削除
		part().mospcode().getMCodeDao().delete(dto);
		// コミット
		commit();
		// モード設定
		vo.setMode(CodeMasterCardVo.MODE_INSERT);
		// メッセージ設定
		vo.setMessage(getMessage(MospConst.MSG_DELETE, ""));
	}
	
	/**
	 * モード設定
	 * @throws Exception 	例外処理が発生した場合
	 */
	private void setMode() throws Exception {
		CodeMasterCardVo vo = (CodeMasterCardVo)getVo();
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(CodeMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(CodeMasterCardVo.MODE_UPDATE);
		}
	}
	
}
